Index: /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/HeuristicLab.Services.Access-3.3.Tests.csproj
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/HeuristicLab.Services.Access-3.3.Tests.csproj	(revision 6840)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/HeuristicLab.Services.Access-3.3.Tests.csproj	(revision 6840)
@@ -0,0 +1,74 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>
+    </ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{70C5A73A-148C-45A2-938F-F8F6DAA80A02}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Services.Access.Tests</RootNamespace>
+    <AssemblyName>HeuristicLab.Services.Access-3.3.Tests</AssemblyName>
+    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <ProjectTypeGuids>{3AC096D0-A1C2-E12C-1390-A8335801FDAB};{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}</ProjectTypeGuids>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="Microsoft.VisualStudio.QualityTools.UnitTestFramework, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL" />
+    <Reference Include="System" />
+    <Reference Include="System.Core">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data.Linq" />
+    <Reference Include="System.ServiceModel" />
+  </ItemGroup>
+  <ItemGroup>
+    <CodeAnalysisDependentAssemblyPaths Condition=" '$(VS100COMNTOOLS)' != '' " Include="$(VS100COMNTOOLS)..\IDE\PrivateAssemblies">
+      <Visible>False</Visible>
+    </CodeAnalysisDependentAssemblyPaths>
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="UnitTest.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.Services.Access.DataAccess\3.3\HeuristicLab.Services.Access.DataAccess-3.3.csproj">
+      <Project>{0F652437-998A-4EAB-8BF1-444B5FE8CE97}</Project>
+      <Name>HeuristicLab.Services.Access.DataAccess-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Services.Access\3.3\HeuristicLab.Services.Access-3.3.csproj">
+      <Project>{9FAC0B23-2730-452A-9BA0-D7CA1746C541}</Project>
+      <Name>HeuristicLab.Services.Access-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="App.config" />
+  </ItemGroup>
+  <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/Properties/AssemblyInfo.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/Properties/AssemblyInfo.cs	(revision 6840)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/Properties/AssemblyInfo.cs	(revision 6840)
@@ -0,0 +1,35 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Services.Access.DataAccess-3.3.Tests")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("Microsoft")]
+[assembly: AssemblyProduct("HeuristicLab.Services.Access.DataAccess-3.3.Tests")]
+[assembly: AssemblyCopyright("Copyright © Microsoft 2011")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("034f8119-0165-46e9-909a-42171fc9c8e8")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/UnitTest.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/UnitTest.cs	(revision 6840)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access-3.3.Tests/UnitTest.cs	(revision 6840)
@@ -0,0 +1,76 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using DA = HeuristicLab.Services.Access.DataAccess;
+using DT = HeuristicLab.Services.Access.DataTransfer;
+
+namespace HeuristicLab.Services.Access.Tests {
+  [TestClass]
+  public class UnitTest {
+
+    [TestMethod]
+    public void ClearDB() {
+      using (DA.ClientManagementDataContext context = new DA.ClientManagementDataContext()) {
+        context.ExecuteCommand("DELETE FROM dbo.ResourceResourceGroup");
+        context.ExecuteCommand("DELETE FROM dbo.Resource");
+        context.ExecuteCommand("DELETE FROM dbo.ClientConfiguration");
+        context.ExecuteCommand("DELETE FROM dbo.ClientError");
+        context.ExecuteCommand("DELETE FROM dbo.ClientLog");
+        context.ExecuteCommand("DELETE FROM dbo.ClientType");
+        context.ExecuteCommand("DELETE FROM dbo.Country");
+        context.ExecuteCommand("DELETE FROM dbo.OperatingSystem");
+        context.ExecuteCommand("DELETE FROM dbo.ResourcePlugin");
+        context.ExecuteCommand("DELETE FROM dbo.Plugin");
+        context.ExecuteCommand("DELETE FROM dbo.UserGroupUserGroup");
+        context.ExecuteCommand("DELETE FROM dbo.UserGroup");
+      }
+    }
+
+    [TestMethod]
+    public void AddClientTest() {
+      ClearDB();
+      AccessService service = new AccessService();
+      DT.ClientConfiguration config = new DT.ClientConfiguration() { Description = "fatConfig", Hash = "xyz" };
+      DT.Country country = new DT.Country() { Name = "Austria" };
+      DT.ClientType clientType = new DT.ClientType() { Name = "Client" };
+      DT.OperatingSystem os = new DT.OperatingSystem() { Name = "Windows 7" };
+
+      DT.Client client = new DT.Client() {
+        ClientConfiguration = config,
+        ClientType = clientType,
+        Country = country,
+        Description = "testClient",
+        HeuristicLabVersion = "3.3.6",
+        MemorySize = 512,
+        NumberOfCores = 4,
+        Name = "testClient",
+        OperatingSystem = os,
+        ProcessorType = "Intel i7",
+        Timestamp = DateTime.Now
+      };
+
+      Guid id = service.AddClient(client);
+      Assert.IsTrue(service.ClientExists(id));
+    }
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.dbml
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.dbml	(revision 6839)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.dbml	(revision 6840)
@@ -13,17 +13,17 @@
       <Association Name="Resource_ResourcePlugin" Member="ResourcePlugins" ThisKey="Id" OtherKey="ResourceId" Type="ResourcePlugin" />
       <Type Name="Client" InheritanceCode="Client" IsInheritanceDefault="true">
-        <Column Name="ClientConfiguration" Member="ClientConfigurationId" Storage="_ClientConfiguration" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="false" />
-        <Column Name="ClientType" Member="ClientTypeId" Storage="_ClientType" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="false" />
         <Column Name="HeuristicLabVersion" Type="System.String" DbType="NVarChar(MAX)" CanBeNull="false" />
-        <Column Name="Country" Member="CountryId" Storage="_Country" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="false" />
-        <Column Name="OperatingSystem" Member="OperatingSystemId" Storage="_OperatingSystem" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="false" />
         <Column Name="MemorySize" Type="System.Int32" DbType="Int" CanBeNull="true" />
         <Column Name="Timestamp" Type="System.DateTime" DbType="DateTime" CanBeNull="true" />
         <Column Name="NumberOfCores" Type="System.Int32" DbType="Int" CanBeNull="true" />
         <Column Name="ProcessorType" Type="System.String" DbType="NVarChar(MAX)" CanBeNull="true" />
-        <Association Name="Client_ClientType" Member="ClientType" Storage="_ClientTypes" ThisKey="ClientTypeId" OtherKey="Id" Type="ClientType" Cardinality="One" />
-        <Association Name="Client_OperatingSystem" Member="OperatingSystem" Storage="_OperatingSystems" ThisKey="OperatingSystemId" OtherKey="Id" Type="OperatingSystem" Cardinality="One" />
-        <Association Name="Client_Country" Member="Country" Storage="_Countries" ThisKey="CountryId" OtherKey="Id" Type="Country" Cardinality="One" />
-        <Association Name="Client_ClientConfiguration" Member="ClientConfiguration" ThisKey="ClientConfigurationId" OtherKey="Id" Type="ClientConfiguration" Cardinality="One" />
+        <Column Name="ClientTypeId" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="false" />
+        <Column Name="OperatingSystemId" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="false" />
+        <Column Name="ClientConfigurationId" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="false" />
+        <Column Name="CountryId" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="false" />
+        <Association Name="ClientType_Client" Member="ClientType" ThisKey="ClientTypeId" OtherKey="Id" Type="ClientType" IsForeignKey="true" />
+        <Association Name="OperatingSystem_Client" Member="OperatingSystem" ThisKey="OperatingSystemId" OtherKey="Id" Type="OperatingSystem" IsForeignKey="true" />
+        <Association Name="Country_Client" Member="Country" ThisKey="CountryId" OtherKey="Id" Type="Country" IsForeignKey="true" />
+        <Association Name="ClientConfiguration_Client" Member="ClientConfiguration" ThisKey="ClientConfigurationId" OtherKey="Id" Type="ClientConfiguration" IsForeignKey="true" />
       </Type>
       <Type Name="ClientGroup" InheritanceCode="ClientGroup" />
@@ -78,5 +78,4 @@
       <Column Name="Id" AutoSync="Never" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" IsPrimaryKey="true" IsDbGenerated="true" CanBeNull="false" />
       <Column Name="Name" Type="System.String" DbType="NVarChar(MAX) NOT NULL" CanBeNull="false" />
-      <Association Name="Client_ClientType" Member="Client" ThisKey="Id" OtherKey="ClientTypeId" Type="Client" IsForeignKey="true" />
     </Type>
   </Table>
@@ -85,5 +84,4 @@
       <Column Name="Id" AutoSync="Never" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" IsPrimaryKey="true" IsDbGenerated="true" CanBeNull="false" />
       <Column Name="Name" Type="System.String" DbType="NVarChar(MAX) NOT NULL" CanBeNull="false" />
-      <Association Name="Client_OperatingSystem" Member="Client" ThisKey="Id" OtherKey="OperatingSystemId" Type="Client" IsForeignKey="true" />
     </Type>
   </Table>
@@ -92,5 +90,4 @@
       <Column Name="Id" AutoSync="Never" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" IsPrimaryKey="true" IsDbGenerated="true" CanBeNull="false" />
       <Column Name="Name" Type="System.String" DbType="NVarChar(MAX) NOT NULL" CanBeNull="false" />
-      <Association Name="Client_Country" Member="Client" ThisKey="Id" OtherKey="CountryId" Type="Client" IsForeignKey="true" />
     </Type>
   </Table>
@@ -100,5 +97,4 @@
       <Column Name="Hash" Type="System.String" DbType="NVarChar(MAX) NOT NULL" CanBeNull="false" />
       <Column Name="Description" Type="System.String" DbType="NVarChar(MAX)" CanBeNull="true" />
-      <Association Name="Client_ClientConfiguration" Member="Client" ThisKey="Id" OtherKey="ClientConfigurationId" Type="Client" IsForeignKey="true" />
     </Type>
   </Table>
Index: /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.dbml.layout
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.dbml.layout	(revision 6839)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.dbml.layout	(revision 6840)
@@ -59,5 +59,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(5.875 : 2.07859537760417); (5.875 : 2.34875); (8.125 : 2.34875)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(5.875 : 2.07859537760417); (5.875 : 2.34875); (8.125 : 2.34875)]" fixedFrom="Algorithm" fixedTo="Algorithm">
       <AssociationMoniker Name="/ClientManagementDataContext/Resource/Resource_ClientLog" />
       <nodes>
@@ -115,25 +115,4 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(3.75 : 2.5); (3.375 : 2.125); (3.375 : 1.09699625651042); (2.5 : 1.09699625651042)]" fixedFrom="NotFixed" fixedTo="NotFixed">
-      <AssociationMoniker Name="/ClientManagementDataContext/Client/Client_ClientType" />
-      <nodes>
-        <classShapeMoniker Id="c964402f-99b7-4355-b9ad-279a2a7cf692" />
-        <classShapeMoniker Id="38891c77-8166-44c9-8dd5-da45900c45f3" />
-      </nodes>
-    </associationConnector>
-    <associationConnector edgePoints="[(3.75 : 2.75324875651042); (2.5 : 2.75324875651042)]" fixedFrom="NotFixed" fixedTo="NotFixed">
-      <AssociationMoniker Name="/ClientManagementDataContext/Client/Client_OperatingSystem" />
-      <nodes>
-        <classShapeMoniker Id="c964402f-99b7-4355-b9ad-279a2a7cf692" />
-        <classShapeMoniker Id="cb6a29ca-7ef1-4721-9108-b64558f282a6" />
-      </nodes>
-    </associationConnector>
-    <associationConnector edgePoints="[(3.75 : 3.59699625651042); (2.5 : 3.59699625651042)]" fixedFrom="NotFixed" fixedTo="NotFixed">
-      <AssociationMoniker Name="/ClientManagementDataContext/Client/Client_Country" />
-      <nodes>
-        <classShapeMoniker Id="c964402f-99b7-4355-b9ad-279a2a7cf692" />
-        <classShapeMoniker Id="c7dfcb39-11e2-47ec-8a48-4e41e2901893" />
-      </nodes>
-    </associationConnector>
     <classShape Id="9f63fd2b-4410-4817-99d4-648466eacddd" absoluteBounds="3.625, 5.625, 2, 1.1939925130208333">
       <DataClassMoniker Name="/ClientManagementDataContext/ResourcePlugin" />
@@ -149,5 +128,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(5.90625 : 2.07859537760417); (5.90625 : 6.22199625651042); (5.625 : 6.22199625651042)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(5.90625 : 2.07859537760417); (5.90625 : 6.22199625651042); (5.625 : 6.22199625651042)]" fixedFrom="Algorithm" fixedTo="Algorithm">
       <AssociationMoniker Name="/ClientManagementDataContext/Resource/Resource_ResourcePlugin" />
       <nodes>
@@ -207,9 +186,30 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(3.75 : 4.64505126953125); (2.5 : 4.64505126953125)]" fixedFrom="NotFixed" fixedTo="NotFixed">
-      <AssociationMoniker Name="/ClientManagementDataContext/Client/Client_ClientConfiguration" />
-      <nodes>
-        <classShapeMoniker Id="c964402f-99b7-4355-b9ad-279a2a7cf692" />
+    <associationConnector edgePoints="[(2.5 : 1.09699625651042); (4.46848483471003 : 1.09699625651042); (4.46848483471003 : 2.5)]" fixedFrom="Algorithm" fixedTo="Caller">
+      <AssociationMoniker Name="/ClientManagementDataContext/ClientType/ClientType_Client" />
+      <nodes>
+        <classShapeMoniker Id="38891c77-8166-44c9-8dd5-da45900c45f3" />
+        <classShapeMoniker Id="c964402f-99b7-4355-b9ad-279a2a7cf692" />
+      </nodes>
+    </associationConnector>
+    <associationConnector edgePoints="[(2.5 : 2.72199625651042); (3.75 : 2.72199625651042)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+      <AssociationMoniker Name="/ClientManagementDataContext/OperatingSystem/OperatingSystem_Client" />
+      <nodes>
+        <classShapeMoniker Id="cb6a29ca-7ef1-4721-9108-b64558f282a6" />
+        <classShapeMoniker Id="c964402f-99b7-4355-b9ad-279a2a7cf692" />
+      </nodes>
+    </associationConnector>
+    <associationConnector edgePoints="[(2.5 : 3.59699625651042); (3.75 : 3.59699625651042)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+      <AssociationMoniker Name="/ClientManagementDataContext/Country/Country_Client" />
+      <nodes>
+        <classShapeMoniker Id="c7dfcb39-11e2-47ec-8a48-4e41e2901893" />
+        <classShapeMoniker Id="c964402f-99b7-4355-b9ad-279a2a7cf692" />
+      </nodes>
+    </associationConnector>
+    <associationConnector edgePoints="[(2.5 : 4.64505126953125); (3.75 : 4.64505126953125)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+      <AssociationMoniker Name="/ClientManagementDataContext/ClientConfiguration/ClientConfiguration_Client" />
+      <nodes>
         <classShapeMoniker Id="3aef9298-1092-45fa-bf96-8dd25d61c2f8" />
+        <classShapeMoniker Id="c964402f-99b7-4355-b9ad-279a2a7cf692" />
       </nodes>
     </associationConnector>
